Subject: Re: [X2Go-Dev] Bug#804: slot argument mismatch in ONMainWindow::slotTunnelOk causes hang during connect

From: Mihai Moldovan <[email-masked]>
Date: Tue, 10 Mar 2015 17:22:28 +0100

On 10.03.2015 11:43 AM, Will Wagner wrote:
> So today I can unfortunately still reproduce this issue. It seems
> like yesterday there must have been something going on with my
> network which altered the timing of events.

Btw, I think this has nothing to do with the network. On Windows, Xorg
(and sshd) must be started whenever X2Go Client starts up, so if you
start X2Go Client and connect to a session *fast enough* after startup,
you can trigger this race condition.

> The debug log I get now is: [...]
> x2go-DEBUG-../src/onmainwindow.cpp:5176> Waiting for win-servers.
> QObject::connect: Incompatible sender/receiver arguments
> QSingleShotTimer::timeout() --> ONMainWindow::slotTunnelOk(int)
> x2go-DEBUG-../src/sshprocess.cpp:157> Direct tunnel: waiting for
> connections on "localhost":31004
>
> x2go-DEBUG-../src/onmainwindow.cpp:9316> got localhost
> x2go-DEBUG-../src/onmainwindow.cpp:9344> Port already used: 6001
> x2go-DEBUG-../src/onmainwindow.cpp:9498> X is started.
> x2go-DEBUG-../src/onmainwindow.cpp:9865> All winservers are started.
>
>
>
> Looking at the change you made I don't believe you are allowed to
> connect a signal emitting no arguments to a slot that requires an
> argument and hence the incompatible sender/receiver argument error.

Yes. The problem at hand is that this parameter is purely optional
anyway and never used.

I totally missed that "this" in that context does not refer to
slotTunnelOk(int) but QSingleShotTimer::timeout(), which has no parameter.

http://code.x2go.org/releases/binary-win32/x2goclient/tmp/x2goclient-4.0.4.0-2015.03.10-ffc56f3-setup.exe

Mihai